;Character-oriented Device Driver Example (DOSPLUS 3.5 Manual)
;Note: Correction by KR-L to filter - return Z based on data
;
;	DOSPLUS SYSTEM ENTRY POINTS AND VARIABLES
;
DSP@	EQU	0033H
DSPLY@	EQU	4467H
HMEM$	EQU	4049H	;MODEL3 4411H
;
;	MODEL I/III RS232 DRIVER
;
ENTCNT	EQU	1
;
;	CHARACTER DEFINITIONS
;
ETX	EQU	3
LF	EQU	10
CR	EQU	13
;
;	HARDWARE ADDRESSES
;
RSTAT	EQU	0EAH		;UART STAT PORT
RDATA	EQU	0EBH		;RS232 DATA PORT
;
;	INITIALIZATION CODE SEQUENCE
;
;	ENT	BC =>		LOW$
;		DE =>		HIGH$
;		HL =>		COMMAND LINE
;		IX =>		DCB
;		IY =>		DCB DESCRIPTOR
;
	ORG	5200H
;
START	PUSH	DE		;SAVE HIGH@,
	LD	HL,TITLE	;'DRIVER TITLE'
	CALL	DSPLY@		;LEN+TERM
;
;	FETCH MEMORY FROM DOS
;
	POP	HL		;GET HIGH$
	LD	BC,ENDDVR-BEGDVR
	OR	A		;CLR CRY
	SBC	HL,BC		;HIGH$-LEN DRIVER
	LD	(HMEM$),HL	;NEW TOP MEM
	INC	HL		;HL => BLOCK

	PUSH	HL		;SAVE => START FREE
	LD	BC,BEGDVR
	OR	A
	SBC	HL,BC		;HL = OFFSET
	LD	C,L
	LD	B,H		;BC = OFFSET

	LD	(MOD00),IY	;PUT DCBTBL ENTRY IN PRG
;
;	ADJUST DRIVER ADDRESSES
;
	LD	IY,TABLE	;IY => ADD TABLE
	LD	A,ENTCNT	;ENTRY COUNT
ADJ1	LD	L,(IY+0)
	LD	H,(IY+1)	;HL => ADD LOCATION
	LD	E,(HL)
	INC	HL
	LD	D,(HL)		;DE = ADDRESS
	EX	DE,HL		;HL = ADDRESS
	ADD	HL,BC		;HL = NEW ADDRESS
	EX	DE,HL		;DE = NEW ADDRESS
	LD	(HL),D
	DEC	HL
	LD	(HL),E		;SET NEW ADD
	LD	DE,2		;OFFSET
	ADD	IY,DE		;IY => NEXT ADD
	DEC	A		;DONE?
	JR	NZ,ADJ1		;IF NOT
	POP	DE		;DE => START FREE
;
;	INSTALL DRIVER HERE
;
	LD	A,40H		;GET FILTER STAT
	AND	(IX+0)		;FROM OLD DCB
	OR	3		;SET INPUT/OUTP(JT TYPE
	LD	(IX+0),A	;AND REPLACE IN DCB
	LD	(IX+1),E	;ADD TO DCB
	LD	(IX+2),D	;ADD TO DCB
	LD	HL,BEGDVR	;HL => DRIVER
	LD	BC,ENDDVR-BEGDVR
	LDIR			;MOVE!
;
	LD	HL,MES1		;'DRIVER INSTALLED AT'
	CALL	DSPLY@
	LD	L,(IX+1)
	LD	H,(IX+2)	;HL => DRIVER
	CALL	BINHEX		;BIN TO HEX CONV
	LD	A,CR		;C/R
	CALL	DSP@		;OUTPUT
;
	RET
;
;	BIN TO ASCII HEX OUTPUT
;
;	ENT	HL =		BINARY WORD
;
BINHEX	LD	A,H		;MSB
	CALL	OHEX1		;OUTPUT
	LD	A,L		;LSB
OHEX0	CALL	OHEX1		;OUTPUT
	LD	A,'H'		;HEX ADDRESS
	JP	DSP@		;OUTPUT
;
OHEX1	PUSH	AF		;SAVE BYTE
	RRA
	RRA
	RRA
	RRA			;MSB TO LSB
	CALL	OHEX2		;OUTPUT DIGIT
	POP	AF		;GET BYTE
OHEX2	AND	0FH		;LSB
	ADD	A,90H
	DAA
	ADC	A,40H		;CONVERT TRICK
	DAA
	JP	DSP@		;OUTPUT
;
;	TABLE OF NON-RELOCATABLE ADDRESSES
;
TABLE	DEFW	REF00
;
;	MESSAGES AND TEXT STRINGS
;
TITLE	DEFM	'RS/DVR - DOSPLUS RS232 driver - 3.50'
	DEFB	LF
	DEFM	'(c) Copyright 1983, Micro-Systems Software Inc.'
	DEFB	LF
	DEFB	CR
;
MES1	DEFM	'Driver installed at '
	DEFB	ETX
;
;	RS232 DRIVER
;
;	ENT:	C=CHR TO OUTPUT
;		IX=>DCB
;
;	DETERMINE INPUT OR OUTPUT
;
BEGDVR	EQU	$
	PUSH	IY		;SAVE REG
MOD00	EQU	$+2
	LD	IY,$-$		;GET DCB TABLE ENTRY
	LD	L,(IY+2)	;GET FILTER ADDR
	LD	H,(IY+3)
	POP	IY		;RESTORE
	BIT	1,B		;OUTPUT OPERATION?
	JR	NZ,RSOUT	;YES
;
;	INPUT BYTE FROM RS232
;
RSIN0	IN	A,(RSTAT)	;RX REG FULL?
	AND	80H		;WELL?
	RET	Z		;IF, EMPTY
	IN	A,(RDATA)	;GET DATA BYTE
	JR	RFLT		;FILTER CHR AND RETURN
;
;	OUTPUT BYTE TO RS232
;
RSOUT	IN	A,(RSTAT)	;TX REG EWTY?
	AND	40H		;VELL?
	JR	Z,RSOUT		;WAIT FOR EMPTY
	LD	A,C		;GET CHR
REF00	EQU	$+1
	CALL	RFLT		;FILTER CHR
	OUT	(RDATA),A	;XMIT CHR
	RET
;
;	FILTER CHR
;
;	ENT	A CHARACTER TO BE FILTERED
;
;	EXT	A RESULT OF FILTER
;		Z SET IF RESULT 0
;
RFLT	BIT	6,(IX+0)	;FILTER?
	JR	Z,RFLT2		;NO corrected by KR-L
	LD	B,(HL)		;GET TABLE LENGTH
	INC	HL		;HL=>TABLE ENTRIES
RFLT0	CP	(HL)		;MATCH?
	INC	HL		;HL=>XLATED VALUE
	JR	NZ,RFLT1	;NO MATCH
	LD	A,(HL)		;GET XLATED CHR
RFLT1	INC	HL		;HL=>NEXT ENTRY
	JR	Z,RFLT2		;IF MATCH
	DJNZ	RFLT0		;TILL DONE
RFLT2	OR	A		;NZ STAT
	RET
;
ENDDVR	EQU	$
	END	START

